

import numpy as np
import matplotlib.pyplot as plt

# false values to assign to cancelled category variables
C = 0.2 # cancelled for different reason unrelated to floods
LF = 0 # cancelled due to low floods
U = 0.3 # unknown data

kuomboka = [[2024,202],[2023,LF],[2022,190],[2021,C],[2020,186],[2019,LF],
             [2018,209],[2017,189],[2016,LF],[2015,LF],[2014,C],[2013,201],
             [2012,LF],[2011,197],[2010,198],[2009,192],[2008,194],[2007,181],
             [2006,189],[2005,LF],[2004,185],[2003,186],[2002,178],[2001,181],
             [2000,U],[1999,176]]

# Separate list of kuomboka year and kuomboka day
kuom_year = []
kuom_day = []

length = len(kuomboka)

for i in range(length):
    kuom_year.append(kuomboka[i][0])
    kuom_day.append(kuomboka[i][1])

# Setting colour legend
col = []
for i in range(len(kuom_day)):
    if kuom_day[i] == LF:
        col.append('red')
    elif kuom_day[i] == U:
        col.append('black')  
    elif kuom_day[i] == C:
        col.append('gray')
    else:
        col.append('black')

# Scatterplot
fig, ax = plt.subplots()


# Plot the LF points as red bands
band_width = 1.0  # Width of the bands; adjust as needed

# Special grey band behind the scatter point for 2020 to account for Covid cancellation
plt.axvspan(2020 - band_width / 2, 2020 + band_width / 2, color='#d8d8d8', alpha=1)

for i in range(len(kuom_day)):
    if kuom_day[i] == LF:
        plt.axvspan(kuom_year[i] - band_width / 2, kuom_year[i] + band_width / 2, color='#ffb2b2', alpha=1)

# Plot the C points as grey bands
for i in range(len(kuom_day)):
    if kuom_day[i] == C:
        plt.axvspan(kuom_year[i] - band_width / 2, kuom_year[i] + band_width / 2, color='#d8d8d8', alpha=1)

# Plot the U points as black bands
for i in range(len(kuom_day)):
    if kuom_day[i] == U:
        plt.axvspan(kuom_year[i] - band_width / 2, kuom_year[i] + band_width / 2, color='#737373', alpha=1)
        
# Plot the points that are not LF, C, or U
for i in range(len(kuom_day)):
    if kuom_day[i] != LF and kuom_day[i] != C and kuom_day[i] != U:
        plt.scatter(kuom_year[i], kuom_day[i], c=col[i], cmap=None, edgecolor='black')

plt.xlabel("Year")
plt.ylabel("Day of year Kuomboka was held \n(days elapsed since Oct 1st of previous year)")
plt.show()




